//- Should not be needed, since it is included globally...
include /components/mixins.pug
+section("DIY TTL logic gates")
  +subsection("Extra information")
    +h5("A brief history of logic types")
    p
      | Today nearly all integrated circuits use
      | <abbr title="Complementary Metal-Oxide Semiconductor">CMOS</abbr>
      | for their construction, both digital and analogue.
      | As you might guess this wasn't always the case.
    p
      | Before CMOS, there was
      | <abbr title="Transistor to Transistor Logic">TTL</abbr>.
      | With it's higher power consumption, and increased circuit and
      | manufacturing complexity for larger IC's, it is not hard to
      | see why it was replaced by CMOS.
      | TTL circuits are on the other hand really easy to design and build
      | with discrete components on breadboards. CMOS has a few side-effects,
      | such as gate-capacitance, that have to be taken into account while
      | designing circuits. TTL does not have these effects, making them
      | ideal to start learning how to make your own logic gates and circuits.
      | Apart from these side-effects, the same principles apply to both.
    p
      | TTL in turn was preceded by
      | <abbr title="Diode-Resistor Logic">DRL</abbr>.
      | DRL was quite limited and as a result fairly shortlived.
      | It was quickly followed by
      | <abbr title="Diode-Transistor Logic">DTL</abbr>.
      | DTL allowed fairly complex circuits to be created while still keeping
      | cost and component count down.
      | Going even further back we find the vacuum tubes (or electron valves),
      | but those are completely out of scope for this workshop.
    +h5("Meet your transistors: BC547 & BC557")
    p
      | The BC547 & BC557 are two general purpose transistors, making them
      | useful in a variety of scenarios. The BC547 is an NPN transistor while
      | the BC557 is PNP transistors.
      | Since their specifications are matched (within &pm; 10%), they
      | are known as a complementary pair, or complementary transistors.
    p
      | BC547 and BC557 are European part numbers and might not
      | be that easy to find in other parts of the world. The specifics don't
      | really matter, any general NPN & PNP transistor will do. Often times
      | the datasheet mentions the complementary part number.
      br
      | They can, for example, be easily substituted by 2N4401 and 2N4403
      | respectively.
  +subsection("Inverter")
    p
      | This is the simplest of the logic gates, requiring only one transistor
      | and two resistors to build it. Either the BC547 or the BC557 can be used
      | to create an inverter. Depending on which you choose the inverter will
      | be able to sink or source current respectively.
    p
      | Which type you need, depends on what you plan on connecting to
      | the output. If the output of the inverted will be connected to other
      | logic gates you need the opposite type of the other gates their input;
      | If the next gate has NPN transistors on its input, you will need to build
      | an inverter that is able to source current, for an PNP input you will
      | need and inverter that can sink current.
    p
      | For large circuits this can quickly become cumbersome; as you may need
      | to create intermediate stages to converted a sourcing output to a sinking
      | one or vice-versa.
      | Luckily transistors also work as a current-amplifier, meaning that if we
      | provide a small current, for example from a pull-up/down resistor, these
      | problems are solved.
    p
      | If you use pull-up or pull-down resistors, you can build all your logic
      | gates out of the same transistor type; either NPN or PNP.
      | However the final output will still be able to only do one of the two
      | <q>strongly</q>; if a pull-up is used, the current-source will be weak
      | while the sinking abilities will be strong and vice-versa.
      | In most case this is no problem. For example when driving other logic
      | gates.
    +diagram(media_folder + "diagrams/NPN_inverter.jpg", "NPN based inverter", "NPN based inverter circuit")
  +subsection("NAND gate")
    p
      | Apart from the inverter the NAND gate is the simplest gate to build.
      | In fact all <q>not-<q> gates are relatively easy to build, due to
      | inverting nature of transistors.
    p
      | A NAND gate is built up out of two transistors from the same type. Similar to
      | the inverter the NPN type will allow the output to sink current while the PNP
      | type will allow the output the source current.
    +diagram(media_folder + "diagrams/NAND_gate.jpg", "NAND gate", "NAND gate circuit")
  +subsection("AND gate")
    +diagram(media_folder + "diagrams/AND_gate.jpg", "AND gate", "AND gate circuit")
  +subsection("OR gate")
  +subsection("NAND as universal gate")
  +subsection("DTL")
  +subsection("Output types")
    p
      | When looking through datasheets for TTL (and sometimes CMOS) IC's
      | you may come across a few different options for output types.
      | Each of them has its uses and its drawbacks, in the following
      | projects we will go over the different output types.
    +h5("Open-collector")
    +h5("Open-emitter")
    +h5("Push-pull")
    p
      | In order to deal with the problem of having either sourcing or sinking
      | capabilities but not both, we can use a push-pull configuration.
      | The name is derived from the fact that this circuit can both pull and
      | push current through an attached load; but it comes down to that it is
      | able to both sink and source current.
      | In this a transistor pair is connected in series, with the output at
      | the center between the two transistors. The bases of both transistors
      | are connected together. The PNP transistor should be placed on top and
      | the NPN transistor on the bottom.
    p
      | A push-pull configuration will work similar to an inverter; when a high
      | signal is applied the push-pull will sink current, pulling the output
      | low. But this can easily be solved by placing an inverter before the
      | push-pull stage.
    +h5("Tri-state output (high-impedance)")
    p
      | Up to this point the outputs have always eitehr sourced or sunk current,
      | but sometimes you might want to disconnect to output alltogether.
      | This can be achieved with tri-state outputs, these will disconnect the
      | ouput from either supply rail. This disconnect will off-course not be
      | mechanically, like a switch, instead the connections will receive a
      | really high-impedance (~resistance) in the order of a few mega-ohms.
      | electrically speaking the outputs are then disconnected.
